#ifndef View_H
#define View_H

#include <iostream>

#include <QtGui>
//TODO Keep only the usefull includes

#include <Controller.hpp>
#include <ParameterDelegate.hpp>

namespace hatptester{

class MainWindow : public QMainWindow{
	Q_OBJECT

private :
	MainWindow(const MainWindow&);
	MainWindow& operator=(const MainWindow&);

	HATPController& controller;

	QWidget centralPart;
	
	QGroupBox taskBox;
	QListView taskView;
	
	QGroupBox parameterBox;
	const std::string defaultText;
	QTableView parametersView;
	
	QLabel informationsText;

	QAction quitAction;
	QAction sendAction;

	QAction aboutAction;
	
	QCheckBox maxTimeToggle;
	QSpinBox maxTimeValue;
	bool changeToggle;
	QPushButton maxTimeButton;
	
	QPushButton sendButton;
	
	QTimer timer; //This timer will be used to check every half a second that the client is still connected
		
public :
	MainWindow();
	
	void resizeEvent(QResizeEvent* event);
		
public slots:
	void about();
	
	void sendRequest();
	
	void activateSend();
	
	void updateInformations();
	
	void clicTask(const QModelIndex& index);
	
	void periodicCheck();
	
	void maxTimeToggled(int);
	
	void maxTimeChanged(int);
	
	void sendMaxTime();
};

}; //namespace

#endif //View_H
